<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="标题" prop="title">
        <el-input v-model="queryParams.title" placeholder="请输入标题" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="上传时间" prop="pubtime">
        <el-date-picker v-model="queryParams.pubtime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="daterange"
                        range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" :default-time="['00:00:00', '23:59:59']" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="openForm(undefined)"
                   v-hasPermi="['server:interview-article:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['server:interview-article:export']">导出</el-button>
      </el-col>
              <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

            <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
<!--            <el-table-column label="访谈稿ID" align="center" prop="id" />-->
              <el-table-column label="单位" align="center" prop="departmentName" />
      <el-table-column label="访谈稿标题 " align="center" prop="title" />
<!--      <el-table-column label="访谈描述" align="center" prop="description" />-->
      <el-table-column label="上传时间" align="center" prop="pubtime" width="180">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.pubtime) }}</span>
        </template>
      </el-table-column>
<!--      <el-table-column label="状态" align="center" prop="reportStatus">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.TRS_REPORT_STATUS" :value="scope.row.reportStatus" />
        </template>
      </el-table-column>
      <el-table-column label="备注信息" align="center" prop="reportRemark" />
      <el-table-column label="附件名称" align="center" prop="attachment" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button size="mini" type="text" icon="el-icon-view" @click="handleDetail(scope.row.id)">查看</el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="openForm(scope.row.id)"
                     v-hasPermi="['server:interview-article:update']" v-if="hasSameDepartment(scope.row)">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['server:interview-article:delete']" v-if="hasSameDepartment(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>
    <!-- 对话框(添加 / 修改) -->
    <InterviewArticleForm ref="formRef" @success="getList" />
    <InterviewArticleDetail ref="detailRef" />

  </div>
</template>

<script>
import * as InterviewArticleApi from '@/api/server/interviewarticle';
import InterviewArticleForm from './InterviewArticleForm.vue';
import InterviewArticleDetail from './InterviewArticleDetail.vue';
export default {
  name: "InterviewArticle",
  components: {
          InterviewArticleForm,InterviewArticleDetail
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
              // 总条数
        total: 0,
      // 访谈稿列表
      list: [],
      // 当前用户部门ID
      currentUserDepartmentId: null,
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 选中行
      currentRow: {},
      // 查询参数
      queryParams: {
                    pageNo: 1,
            pageSize: 10,
        title: null,
        description: null,
        pubtime: [],
        departmentId: null,
        reportStatus: null,
        reportRemark: null,
        attachment: null,
        createTime: [],
      },
            };
  },
  created() {
    this.getCurrentUserDepartment();
    this.getList();
  },
  computed: {
    isAdmin() {
      return this.$store.getters.roles.includes('trs_rectify_admin');
    }
  },
  methods: {
    /** 获取当前用户部门信息 */
    async getCurrentUserDepartment() {
      // 这里需要根据你的实际项目获取当前用户部门ID的方式进行调整
      // 可能是从Vuex store中获取，或者调用API获取
      const userInfo = this.$store.state.user;
      this.currentUserDepartmentId = userInfo.deptId; // 假设用户信息中包含部门ID字段deptId
    },

    /** 检查当前用户是否与数据创建人同部门 */
    hasSameDepartment(row) {
      // 假设row中包含departmentId字段表示数据所属部门
      /*console.log(row.departmentId);
      return this.currentUserDepartmentId && (row.departmentId === this.currentUserDepartmentId);*/
      // 获取当前用户角色信息
      const userInfo = this.$store.state.user;
      const roles = userInfo.roles || []; // 假设角色信息存储在roles数组中
      // 如果用户有超管角色（id是1），则返回true
      if (roles.includes("super_admin")  ) {
        return true;
      }
    },

    /** 查询列表 */
    async getList() {
      try {
      this.loading = true;
              const res = await InterviewArticleApi.getInterviewArticlePage(this.queryParams);
        this.list = res.data.list;
        this.total = res.data.total;
      } finally {
        this.loading = false;
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 添加/修改操作 */
    openForm(id) {
      this.$refs["formRef"].open(id);
    },
    handleDetail(id) {
      this.$refs["detailRef"].open(id);
    },
    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id;
      await this.$modal.confirm('是否确认删除访谈稿编号为"' + id + '"的数据项?')
      try {
       await InterviewArticleApi.deleteInterviewArticle(id);
       await this.getList();
       this.$modal.msgSuccess("删除成功");
      } catch {}
    },
    /** 导出按钮操作 */
    async handleExport() {
      await this.$modal.confirm('是否确认导出所有访谈稿数据项?');
      try {
        this.exportLoading = true;
        const data = await InterviewArticleApi.exportInterviewArticleExcel(this.queryParams);
        this.$download.excel(data, '访谈稿.xls');
      } catch {
      } finally {
        this.exportLoading = false;
      }
    },
              }
};
</script>
